<script lang="ts">
  import appearance from "$lib/tidy/stores/appearance.store";
  import { retrieveCurrentColors } from "$lib/tidy/utils/theme.utils";
  import {
    BarChartStacked,
    ChartTheme,
    DonutChart,
    ScaleTypes,
    StackedAreaChart
  } from "@carbon/charts-svelte";
  //import "@carbon/styles/css/styles.css"; // may affect global styles
  import "@carbon/charts-svelte/styles.css";
  import { onMount } from "svelte";
  let currentColors = retrieveCurrentColors($appearance);

  $: theme = $appearance.colorScheme.isDark
    ? ChartTheme.G100
    : ChartTheme.WHITE;
  let donutdata = [
    {
      group: "Dataset 1",
      value: 65000
    },
    {
      group: "Dataset 2",
      value: 29123
    },
    {
      group: "Dataset 3",
      value: 35213
    },
    {
      group: "Dataset 4",
      value: 51213
    }
  ];
  let donutoptions = {
    title: "Donut",
    resizable: true,
    donut: {
      center: {
        label: "Total",
        number: 100000
      }
    },
    tooltip: {
      valueFormatter: (d: any) => d
    },
    toolbar: {
      enabled: false
    },
    theme: $appearance.colorScheme.isDark ? ChartTheme.G100 : ChartTheme.WHITE
  };
  let areadata = [
    {
      group: "Dataset 1",
      date: new Date(2019, 0, 1),
      value: 10000
    },
    {
      group: "Dataset 1",
      date: new Date(2019, 0, 5),
      value: 65000
    },
    {
      group: "Dataset 1",
      date: new Date(2019, 0, 8),
      value: 10000
    },
    {
      group: "Dataset 1",
      date: new Date(2019, 0, 13),
      value: 49213
    },
    {
      group: "Dataset 1",
      date: new Date(2019, 0, 17),
      value: 51213
    },
    {
      group: "Dataset 2",
      date: new Date(2019, 0, 1),
      value: 20000
    },
    {
      group: "Dataset 2",
      date: new Date(2019, 0, 5),
      value: 25000
    },
    {
      group: "Dataset 2",
      date: new Date(2019, 0, 8),
      value: 60000
    },
    {
      group: "Dataset 2",
      date: new Date(2019, 0, 13),
      value: 30213
    },
    {
      group: "Dataset 2",
      date: new Date(2019, 0, 17),
      value: 55213
    },
    {
      group: "Dataset 3",
      date: new Date(2019, 0, 1),
      value: 30000
    },
    {
      group: "Dataset 3",
      date: new Date(2019, 0, 5),
      value: 20000
    },
    {
      group: "Dataset 3",
      date: new Date(2019, 0, 8),
      value: 40000
    },
    {
      group: "Dataset 3",
      date: new Date(2019, 0, 13),
      value: 60213
    },
    {
      group: "Dataset 3",
      date: new Date(2019, 0, 17),
      value: 25213
    }
  ];
  let areaoptions = {
    title: "Stacked area (time series)",
    axes: {
      left: {
        stacked: true,
        scaleType: ScaleTypes.LINEAR,
        mapsTo: "value"
      },
      bottom: {
        scaleType: ScaleTypes.TIME,
        mapsTo: "date"
      }
    },
    curve: "curveMonotoneX",
    height: "100%",
    zoomBar: {
      top: {
        enabled: true
      }
    },
    toolbar: {
      enabled: false
    },
    tooltip: {
      valueFormatter: (d: any) => d
    },
    theme: $appearance.colorScheme.isDark ? ChartTheme.G100 : ChartTheme.WHITE
  };
  $: console.log({ donutoptions, areaoptions });
  onMount(() => {
    let backdrop = document.getElementsByClassName(
      "chart-grid-backdrop"
    )[1] as HTMLElement;
    console.log({ backdrop });
    backdrop.style.fill = currentColors?.bgs1!;
    let mainDonutFigure = document.getElementsByClassName(
      "donut-figure"
    )[0] as HTMLElement;
    mainDonutFigure.style.fill = currentColors?.fgs1!;
    mainDonutFigure.style.fontSize = "5rem";
  });
</script>

<!-- <DonutChart data={donutdata} options={donutoptions} /> -->

<!-- <StackedAreaChart data={areadata} options={areaoptions} style="padding:2rem;" /> -->

<BarChartStacked data={areadata} options={areaoptions} />
